Index: palm/trunk/SOURCE/coriolis.f90
===================================================================
--- palm/trunk/SOURCE/coriolis.f90	(revision 3178)
+++ palm/trunk/SOURCE/coriolis.f90	(revision 3182)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Remove masking of geostrophic wind forcing in offline nesting case
 ! 
 ! Former revisions:
@@ -109,5 +109,5 @@
            
        USE control_parameters,                                                 &
-           ONLY:  f, forcing, fs, message_string
+           ONLY:  f, fs, message_string, nesting_offline
            
        USE indices,                                                            &
@@ -123,8 +123,6 @@
        INTEGER(iwp) ::  k          !< running index z direction 
 
-       REAL(wp)     ::  flag       !< flag to mask topography
-       REAL(wp)     ::  flag_force !< flag to mask large-scale pressure gradient in case larger-scale forcing is applied
-
-       flag_force = MERGE( 0.0_wp, 1.0_wp, forcing )
+       REAL(wp)     ::  flag           !< flag to mask topography
+
 !
 !--    Compute Coriolis terms for the three velocity components
@@ -144,6 +142,5 @@
                       tend(k,j,i) = tend(k,j,i) + f  *    ( 0.25_wp *          &
                                    ( v(k,j,i-1) + v(k,j,i) + v(k,j+1,i-1) +    &
-                                     v(k,j+1,i) ) - vg(k) * flag_force         &
-                                                          ) * flag           &
+                                     v(k,j+1,i) ) - vg(k) ) * flag             &
                                                 - fs *    ( 0.25_wp *          &
                                    ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) +  &
@@ -167,6 +164,5 @@
                       tend(k,j,i) = tend(k,j,i) - f *     ( 0.25_wp *          &
                                    ( u(k,j-1,i) + u(k,j,i) + u(k,j-1,i+1) +    &
-                                     u(k,j,i+1) ) - ug(k) * flag_force         &
-                                                          ) * flag
+                                     u(k,j,i+1) ) - ug(k) ) * flag
                    ENDDO
                 ENDDO
@@ -212,5 +208,5 @@
            
        USE control_parameters,                                                 &
-           ONLY:  f, forcing, fs, message_string
+           ONLY:  f, fs, message_string, nesting_offline
            
        USE indices,                                                            &
@@ -227,7 +223,5 @@
 
        REAL(wp)     ::  flag       !< flag to mask topography
-       REAL(wp)     ::  flag_force !< flag to mask large-scale pressure gradient in case larger-scale forcing is applied
-
-       flag_force = MERGE( 0.0_wp, 1.0_wp, forcing )
+
 !
 !--    Compute Coriolis terms for the three velocity components
@@ -244,5 +238,5 @@
                 tend(k,j,i) = tend(k,j,i) + f  *     ( 0.25_wp *               &
                                 ( v(k,j,i-1) + v(k,j,i) + v(k,j+1,i-1) +       &
-                                  v(k,j+1,i) ) - vg(k) * flag_force            &
+                                  v(k,j+1,i) ) - vg(k)                         &
                                                      ) * flag                  &
                                           - fs *     ( 0.25_wp *               &
@@ -261,6 +255,5 @@
                 tend(k,j,i) = tend(k,j,i) - f *        ( 0.25_wp *             &
                                 ( u(k,j-1,i) + u(k,j,i) + u(k,j-1,i+1) +       &
-                                  u(k,j,i+1) ) - ug(k)   * flag_force          &
-                                                       ) * flag
+                                  u(k,j,i+1) ) - ug(k) ) * flag
              ENDDO
 
Index: palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 3178)
+++ palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 3182)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Rename variables in offline nesting mode and flags indicating lateral
+! boundary conditions
 ! 
 ! Former revisions:
@@ -84,9 +85,7 @@
 
     USE control_parameters,                                                    &
-        ONLY :  bc_lr_cyc, bc_ns_cyc, force_bound_l, force_bound_n,            &
-                force_bound_r, force_bound_s,                                  &
-                inflow_l, inflow_n, inflow_r, inflow_s,                        &
-                nest_bound_l, nest_bound_n, nest_bound_r, nest_bound_s,        &
-                outflow_l, outflow_n, outflow_r, outflow_s
+        ONLY :  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,                &
+                bc_dirichlet_s, bc_lr_cyc, bc_ns_cyc, bc_radiation_l,          &
+                bc_radiation_n, bc_radiation_r, bc_radiation_s 
                 
     USE cpulog,                                                                &
@@ -184,24 +183,20 @@
 !-- Neumann-conditions at inflow/outflow/nested boundaries
     IF ( nesting_mode /= 'vertical' )  THEN
-       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l  .OR.  force_bound_l )   &
-       THEN
+       IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
           DO  i = nbgp, 1, -1
              ar(:,nxl-i) = ar(:,nxl)
           ENDDO
        ENDIF
-       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r  .OR.  force_bound_r )   &
-       THEN
+       IF ( bc_dirichlet_r  .OR.  bc_radiation_r )  THEN
           DO  i = 1, nbgp
              ar(:,nxr+i) = ar(:,nxr)
           ENDDO
        ENDIF
-       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s  .OR.  force_bound_s )   &
-       THEN
+       IF ( bc_dirichlet_s  .OR.  bc_radiation_s )  THEN
           DO  i = nbgp, 1, -1
              ar(nys-i,:) = ar(nys,:)
           ENDDO
        ENDIF
-       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n  .OR.  force_bound_n )   &
-       THEN
+       IF ( bc_dirichlet_n  .OR.  bc_radiation_n )  THEN
           DO  i = 1, nbgp
              ar(nyn+i,:) = ar(nyn,:)
@@ -227,7 +222,7 @@
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, force_bound_l, force_bound_n, &
-               force_bound_r, force_bound_s, nest_bound_l, nest_bound_n,       &
-               nest_bound_r, nest_bound_s
+        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,                 &
+               bc_dirichlet_s, bc_lr_cyc, bc_ns_cyc, bc_radiation_l,           &
+               bc_radiation_n, bc_radiation_r, bc_radiation_s, grid_level
         
     USE cpulog,                                                                &
@@ -326,20 +321,20 @@
 !
 !-- Neumann-conditions at inflow/outflow/nested boundaries
-    IF ( nest_bound_l  .OR.  force_bound_l )  THEN
+    IF ( bc_dirichlet_l )  THEN
        DO  i = nbgp_local, 1, -1
          ar(:,nxl_l-i) = ar(:,nxl_l)
        ENDDO
     ENDIF
-    IF ( nest_bound_r  .OR.  force_bound_r )  THEN
+    IF ( bc_dirichlet_r )  THEN
        DO  i = 1, nbgp_local
           ar(:,nxr_l+i) = ar(:,nxr_l)
        ENDDO
     ENDIF
-    IF ( nest_bound_s  .OR.  force_bound_s )  THEN
+    IF ( bc_dirichlet_s )  THEN
        DO  i = nbgp_local, 1, -1
          ar(nys_l-i,:) = ar(nys_l,:)
        ENDDO
     ENDIF
-    IF ( nest_bound_n  .OR.  force_bound_n )  THEN
+    IF ( bc_dirichlet_n )  THEN
        DO  i = 1, nbgp_local
          ar(nyn_l+i,:) = ar(nyn_l,:)
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 3178)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 3182)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Revise Inifor initialization
 ! 
 ! Former revisions:
@@ -535,5 +535,5 @@
 
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  init_3d, netcdf_data_input_interpolate, netcdf_data_input_init_3d
+        ONLY:  init_3d, netcdf_data_input_init_3d
     
     USE particle_attributes,                                                   &
@@ -611,4 +611,5 @@
     REAL(wp)     ::  t_surface !< air temperature at the surface
 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  init_l        !< dummy array used for averaging 3D data to obtain inital profiles 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  p_hydrostatic !< hydrostatic pressure
 
@@ -1006,33 +1007,34 @@
 !-- Arrays to store velocity data from t-dt and the phase speeds which
 !-- are needed for radiation boundary conditions
-    IF ( outflow_l )  THEN
+    IF ( bc_radiation_l )  THEN
        ALLOCATE( u_m_l(nzb:nzt+1,nysg:nyng,1:2),                               &
                  v_m_l(nzb:nzt+1,nysg:nyng,0:1),                               &
                  w_m_l(nzb:nzt+1,nysg:nyng,0:1) )
     ENDIF
-    IF ( outflow_r )  THEN
+    IF ( bc_radiation_r )  THEN
        ALLOCATE( u_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                           &
                  v_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx),                           &
                  w_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx) )
     ENDIF
-    IF ( outflow_l  .OR.  outflow_r )  THEN
+    IF ( bc_radiation_l  .OR.  bc_radiation_r )  THEN
        ALLOCATE( c_u(nzb:nzt+1,nysg:nyng), c_v(nzb:nzt+1,nysg:nyng),           &
                  c_w(nzb:nzt+1,nysg:nyng) )
     ENDIF
-    IF ( outflow_s )  THEN
+    IF ( bc_radiation_s )  THEN
        ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxlg:nxrg),                               &
                  v_m_s(nzb:nzt+1,1:2,nxlg:nxrg),                               &
                  w_m_s(nzb:nzt+1,0:1,nxlg:nxrg) )
     ENDIF
-    IF ( outflow_n )  THEN
+    IF ( bc_radiation_n )  THEN
        ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                           &
                  v_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg),                           &
                  w_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg) )
     ENDIF
-    IF ( outflow_s  .OR.  outflow_n )  THEN
+    IF ( bc_radiation_s  .OR.  bc_radiation_n )  THEN
        ALLOCATE( c_u(nzb:nzt+1,nxlg:nxrg), c_v(nzb:nzt+1,nxlg:nxrg),           &
                  c_w(nzb:nzt+1,nxlg:nxrg) )
     ENDIF
-    IF ( outflow_l  .OR.  outflow_r  .OR.  outflow_s  .OR.  outflow_n )  THEN
+    IF ( bc_radiation_l  .OR.  bc_radiation_r  .OR.  bc_radiation_s  .OR.      &
+         bc_radiation_n )  THEN
        ALLOCATE( c_u_m_l(nzb:nzt+1), c_v_m_l(nzb:nzt+1), c_w_m_l(nzb:nzt+1) )                   
        ALLOCATE( c_u_m(nzb:nzt+1), c_v_m(nzb:nzt+1), c_w_m(nzb:nzt+1) )
@@ -1152,7 +1154,5 @@
     sums_l_l           = 0.0_wp
     sums_wsts_bc_l     = 0.0_wp
-
-
-
+    
 !
 !-- Initialize model variables
@@ -1169,53 +1169,91 @@
           CALL netcdf_data_input_init_3d
 !
-!--       Please note, at the moment INIFOR assumes only an equidistant vertical
-!--       grid. In case of vertical grid stretching, input of inital data 
-!--       need to be inter- and/or extrapolated. 
-!--       Therefore, check if zu grid on file is identical to numeric zw grid. 
-!--       Please note  
-          IF ( ANY( zu(1:nzt+1) /= init_3d%zu_atmos(1:init_3d%nzu) ) )  THEN
-
-             IF( init_3d%lod_u == 1 )                                          &
-                CALL netcdf_data_input_interpolate(                            &
-                                                 init_3d%u_init(nzb+1:nzt+1),  &
-                                                 zu(nzb+1:nzt+1),              &
-                                                 init_3d%zu_atmos )
-                                                 
-             IF( init_3d%lod_v == 1 )                                          &
-                CALL netcdf_data_input_interpolate(                            &
-                                                 init_3d%v_init(nzb+1:nzt+1),  &
-                                                 zu(nzb+1:nzt+1),              &
-                                                 init_3d%zu_atmos )
-                                                 
-!              CALL netcdf_data_input_interpolate( init_3d%w_init(nzb+1:nzt),    &
-!                                                  zw(nzb+1:nzt),                &
-!                                                  init_3d%zw_atmos )
-
-             IF ( .NOT. neutral  .AND.  init_3d%lod_pt == 1 )                  &
-                CALL netcdf_data_input_interpolate(                            &
-                                             init_3d%pt_init(nzb+1:nzt+1),     &
-                                             zu(nzb+1:nzt+1),                  &
-                                             init_3d%zu_atmos )
-                                             
-             IF ( humidity  .AND.  init_3d%lod_q == 1 )                        &
-                CALL netcdf_data_input_interpolate(                            &
-                                             init_3d%q_init(nzb+1:nzt+1),      &
-                                             zu(nzb+1:nzt+1),                  &
-                                             init_3d%zu_atmos )
-          ENDIF
-!
-!--       In case of LOD=1, initialize 1D profiles and 3D data.  
-          IF( init_3d%lod_u == 1 )  u_init = init_3d%u_init
-          IF( init_3d%lod_v == 1 )  v_init = init_3d%v_init    
-          IF( .NOT. neutral  .AND.  init_3d%lod_pt == 1 )                      &
-             pt_init = init_3d%pt_init
-          IF( humidity  .AND.  init_3d%lod_q == 1 )                            &
-             q_init  = init_3d%q_init
-
-!
-!--       Please note, Inifor provides data from nzb+1 to nzt+1. 
-!--       Initialize pt and q with Neumann condition at nzb.
-          IF( .NOT. neutral )  pt_init(nzb) = pt_init(nzb+1)
-          IF( humidity      )  q_init(nzb)  = q_init(nzb+1)
+!--       Please note, Inifor provides data from nzb+1 to nzt. 
+!--       Bottom and top boundary conditions for Inifor profiles are already 
+!--       set (just after reading), so that this is not necessary here.
+!--       Depending on the provided level-of-detail, initial Inifor data is
+!--       either stored on data type (lod=1), or directly on 3D arrays (lod=2). 
+!--       In order to obtain also initial profiles in case of lod=2 (which 
+!--       is required for e.g. damping), average over 3D data.
+          IF( init_3d%lod_u == 1 )  THEN
+             u_init = init_3d%u_init
+          ELSEIF( init_3d%lod_u == 2 )  THEN 
+             ALLOCATE( init_l(nzb:nzt+1) ) 
+             DO  k = nzb, nzt+1
+                init_l(k) = SUM( u(k,nys:nyn,nxl:nxr) )
+             ENDDO
+             init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
+
+#if defined( __parallel )
+             CALL MPI_ALLREDUCE( init_l, u_init, nzt+1-nzb+1,                  &
+                                 MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+             u_init = init_l
+#endif
+             DEALLOCATE( init_l )
+
+          ENDIF
+           
+          IF( init_3d%lod_v == 1 )  THEN  
+             v_init = init_3d%v_init
+          ELSEIF( init_3d%lod_v == 2 )  THEN 
+             ALLOCATE( init_l(nzb:nzt+1) ) 
+             DO  k = nzb, nzt+1
+                init_l(k) = SUM( v(k,nys:nyn,nxl:nxr) )
+             ENDDO
+             init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
+
+#if defined( __parallel )
+             CALL MPI_ALLREDUCE( init_l, v_init, nzt+1-nzb+1,                  &
+                                 MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+             v_init = init_l
+#endif
+             DEALLOCATE( init_l )
+          ENDIF
+          IF( .NOT. neutral )  THEN
+             IF( init_3d%lod_pt == 1 )  THEN
+                pt_init = init_3d%pt_init
+             ELSEIF( init_3d%lod_pt == 2 )  THEN 
+                ALLOCATE( init_l(nzb:nzt+1) ) 
+                DO  k = nzb, nzt+1
+                   init_l(k) = SUM( pt(k,nys:nyn,nxl:nxr) )
+                ENDDO
+                init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
+
+#if defined( __parallel )
+                CALL MPI_ALLREDUCE( init_l, pt_init, nzt+1-nzb+1,               &
+                                    MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+                pt_init = init_l
+#endif
+                DEALLOCATE( init_l )
+             ENDIF
+          ENDIF
+
+
+          IF( humidity )  THEN
+             IF( init_3d%lod_q == 1 )  THEN
+                q_init = init_3d%q_init
+             ELSEIF( init_3d%lod_q == 2 )  THEN 
+                ALLOCATE( init_l(nzb:nzt+1) ) 
+                DO  k = nzb, nzt+1
+                   init_l(k) = SUM( q(k,nys:nyn,nxl:nxr) )
+                ENDDO
+                init_l = init_l / REAL( ( nx + 1 ) * ( ny + 1 ), KIND = wp )
+
+#if defined( __parallel )
+                CALL MPI_ALLREDUCE( init_l, q_init, nzt+1-nzb+1,               &
+                                    MPI_REAL, MPI_SUM, comm2d, ierr )
+#else
+                q_init = init_l
+#endif
+                DEALLOCATE( init_l )
+             ENDIF
+          ENDIF
+
+!
+!--       Write initial profiles onto 3D arrays. Note, only in case of lod = 1, 
+!--       for lod = 2 data is already on 3D arrays.   
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
@@ -1224,12 +1262,18 @@
                 IF( .NOT. neutral  .AND.  init_3d%lod_pt == 1 )                &
                    pt(:,j,i) = pt_init(:)
-                IF( humidity  .AND.  init_3d%lod_q == 1 )                      &
-                   q(:,j,i)  = q_init(:)
+                IF( humidity  .AND.  init_3d%lod_q == 1 )  q(:,j,i) = q_init(:)
              ENDDO
           ENDDO
 !
-!--       MS: What about the geostrophic wind profiles? Actually these
-!--           are not identical to the initial wind profiles in this case. 
-!--           This need to be further revised.
+!--       Exchange ghost points in case of level-of-detail = 2
+          IF( init_3d%lod_u == 2 )   CALL exchange_horiz( u, nbgp )
+          IF( init_3d%lod_v == 2 )   CALL exchange_horiz( v, nbgp )
+          IF( init_3d%lod_w == 2 )   CALL exchange_horiz( w, nbgp )
+          IF( .NOT. neutral  .AND.  init_3d%lod_pt == 2 )                      &
+             CALL exchange_horiz( pt, nbgp )
+          IF( humidity  .AND.  init_3d%lod_q == 2 )                            &
+             CALL exchange_horiz( q, nbgp )
+!
+!--       Set geostrophic wind components.  
           IF ( init_3d%from_file_ug )  THEN
              ug(:) = init_3d%ug_init(:)
@@ -1238,8 +1282,7 @@
              vg(:) = init_3d%vg_init(:)
           ENDIF
-
+          
           ug(nzt+1) = ug(nzt)
           vg(nzt+1) = vg(nzt)
-
 !
 !--       Set inital w to 0
@@ -1815,5 +1858,5 @@
 !--       Use these mean profiles at the inflow (provided that Dirichlet
 !--       conditions are used)
-          IF ( inflow_l )  THEN
+          IF ( bc_dirichlet_l )  THEN
              DO  j = nysg, nyng
                 DO  k = nzb, nzt+1
@@ -1963,20 +2006,20 @@
 !
 !--    Initialize old timelevels needed for radiation boundary conditions
-       IF ( outflow_l )  THEN
+       IF ( bc_radiation_l )  THEN
           u_m_l(:,:,:) = u(:,:,1:2)
           v_m_l(:,:,:) = v(:,:,0:1)
           w_m_l(:,:,:) = w(:,:,0:1)
        ENDIF
-       IF ( outflow_r )  THEN
+       IF ( bc_radiation_r )  THEN
           u_m_r(:,:,:) = u(:,:,nx-1:nx)
           v_m_r(:,:,:) = v(:,:,nx-1:nx)
           w_m_r(:,:,:) = w(:,:,nx-1:nx)
        ENDIF
-       IF ( outflow_s )  THEN
+       IF ( bc_radiation_s )  THEN
           u_m_s(:,:,:) = u(:,0:1,:)
           v_m_s(:,:,:) = v(:,1:2,:)
           w_m_s(:,:,:) = w(:,0:1,:)
        ENDIF
-       IF ( outflow_n )  THEN
+       IF ( bc_radiation_n )  THEN
           u_m_n(:,:,:) = u(:,ny-1:ny,:)
           v_m_n(:,:,:) = v(:,ny-1:ny,:)
@@ -2301,10 +2344,8 @@
 !-- Initialize nudging if required
     IF ( nudging )  CALL nudge_init
-
 !
 !-- Initialize 1D/3D offline-nesting with COSMO model and read data from 
 !-- external file.
-    IF ( large_scale_forcing  .OR.  forcing )  CALL lsf_init
-    
+    IF ( large_scale_forcing  .OR.  nesting_offline )  CALL lsf_init
 !
 !-- Initialize surface forcing corresponding to large-scale forcing. Therein, 
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 3178)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 3182)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Rename variables in mesoscale-offline nesting mode
 ! 
 ! Former revisions:
@@ -342,5 +342,8 @@
         
     USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc, building_height, building_length_x,       &
+        ONLY:  bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,                 &
+               bc_dirichlet_s, bc_lr_cyc, bc_ns_cyc, bc_radiation_l,           &
+               bc_radiation_n, bc_radiation_r, bc_radiation_s,                 &
+               building_height, building_length_x,                             &
                building_length_y, building_wall_left, building_wall_south,     &
                canyon_height, canyon_wall_left, canyon_wall_south,             &
@@ -350,13 +353,9 @@
                dz_stretch_level_end_index, dz_stretch_level_start_index,       &
                dz_stretch_level_start, grid_level,                             &
-               force_bound_l, force_bound_r, force_bound_n, force_bound_s,     &
-               ibc_uv_b, inflow_l, inflow_n, inflow_r, inflow_s,               &
-               masking_method, maximum_grid_level, message_string,             &
-               momentum_advec, nest_domain, nest_bound_l,                      &
-               nest_bound_n, nest_bound_r, nest_bound_s,                       &
-               number_stretch_level_end, number_stretch_level_start, ocean,    &
-               outflow_l, outflow_n, outflow_r, outflow_s, psolver,            & 
-               scalar_advec, topography, topography_grid_convention,           &
-               tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y,   &
+               ibc_uv_b, masking_method, maximum_grid_level, message_string,   &
+               momentum_advec, number_stretch_level_end,                       &
+               number_stretch_level_start,ocean, psolver, scalar_advec,        &
+               topography, topography_grid_convention, tunnel_height,          &
+               tunnel_length, tunnel_width_x, tunnel_width_y,                  &
                tunnel_wall_depth, use_surface_fluxes, use_top_fluxes,          &
                wall_adjustment_factor
@@ -386,12 +385,13 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                           !< index variable along x 
-    INTEGER(iwp) ::  j                           !< index variable along y
-    INTEGER(iwp) ::  k                           !< index variable along z
-    INTEGER(iwp) ::  k_top                       !< topography top index on local PE
-    INTEGER(iwp) ::  n                           !< loop variable for stretching
-    INTEGER(iwp) ::  number_dz                   !< number of user-specified dz values       
-    INTEGER(iwp) ::  nzb_local_max               !< vertical grid index of maximum topography height
-    INTEGER(iwp) ::  nzb_local_min               !< vertical grid index of minimum topography height
+    INTEGER(iwp) ::  i             !< index variable along x 
+    INTEGER(iwp) ::  j             !< index variable along y
+    INTEGER(iwp) ::  k             !< index variable along z
+    INTEGER(iwp) ::  k_top         !< topography top index on local PE
+    INTEGER(iwp) ::  l             !< loop variable 
+    INTEGER(iwp) ::  n             !< loop variable for stretching
+    INTEGER(iwp) ::  number_dz     !< number of user-specified dz values       
+    INTEGER(iwp) ::  nzb_local_max !< vertical grid index of maximum topography height
+    INTEGER(iwp) ::  nzb_local_min !< vertical grid index of minimum topography height
                                       
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_local  !< index for topography top at cell-center
@@ -834,12 +834,12 @@
     nzb_max = k_top + 1
 #endif
-    IF ( inflow_l  .OR.  outflow_l  .OR.  force_bound_l  .OR.  nest_bound_l  .OR.&
-         inflow_r  .OR.  outflow_r  .OR.  force_bound_r  .OR.  nest_bound_r  .OR.&
-         inflow_n  .OR.  outflow_n  .OR.  force_bound_n  .OR.  nest_bound_n  .OR.&
-         inflow_s  .OR.  outflow_s  .OR.  force_bound_s  .OR.  nest_bound_s )    &
+    IF ( bc_dirichlet_l  .OR.  bc_radiation_l     .OR.                         &
+         bc_dirichlet_r  .OR.  bc_radiation_r     .OR.                         &
+         bc_dirichlet_n  .OR.  bc_radiation_n     .OR.                         &
+         bc_dirichlet_s  .OR.  bc_radiation_s )                                &
          nzb_max = nzt
 !   
 !-- Finally, if topography extents up to the model top, limit nzb_max to nzt.
-    nzb_max = MIN( nzb_max, nzt )
+    nzb_max = MIN( nzb_max, nzt ) 
 !
 !-- Determine minimum index of topography. Usually, this will be nzb. In case
@@ -857,4 +857,5 @@
 !-- Initialize boundary conditions via surface type
     CALL init_bc
+
 !
 !-- Allocate and set topography height arrays required for data output
@@ -926,5 +927,5 @@
 #if defined( __parallel )
        CALL MPI_ALLREDUCE( MAXVAL( get_topography_top_index( 's' ) ),          &
-                           nzb_local_max, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )             
+                           nzb_local_max, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )               
 #else
        nzb_local_max = MAXVAL( get_topography_top_index( 's' ) )
